# MAEC Static Features List
# Copyright (c) 2015, The MITRE Corporation
# All rights reserved

static_features_dict = {'file_name' : {'feature_name' : 'file_name'},
                        'file_path' : {'feature_name' : 'file_path'},
                        'size_in_bytes' : {'feature_name' : 'size_in_bytes'},
                        'file_format' : {'feature_name' : 'file_format'},
                        'peak_entropy' : {'feature_name' : 'peak_entropy'},
                        'headers/dos_header/e_cblp' : {'feature_name' : 'e_cblp'},
                        'headers/dos_header/e_cp' : {'feature_name' : 'e_cp'},
                        'headers/dos_header/e_crlc' : {'feature_name' : 'e_crlc'},
                        'headers/dos_header/e_cparhdr' : {'feature_name' : 'e_cparhdr'},
                        'headers/dos_header/e_minalloc' : {'feature_name' : 'e_minalloc'},
                        'headers/dos_header/e_maxalloc' : {'feature_name' : 'e_maxalloc'},
                        'headers/dos_header/e_ss' : {'feature_name' : 'e_ss'},
                        'headers/dos_header/e_sp' : {'feature_name' : 'e_sp'},
                        'headers/dos_header/e_csum' : {'feature_name' : 'e_csum'},
                        'headers/dos_header/e_ip' : {'feature_name' : 'e_ip'},
                        'headers/dos_header/e_cs' : {'feature_name' : 'e_cs'},
                        'headers/dos_header/e_lfarlc' : {'feature_name' : 'e_lfarlc'},
                        'headers/dos_header/e_ovro' : {'feature_name' : 'e_ovro'},
                        'headers/dos_header/e_oemid' : {'feature_name' : 'e_oemid'},
                        'headers/dos_header/e_oeminfo' : {'feature_name' : 'e_oeminfo'},
                        'headers/dos_header/e_lfanew' : {'feature_name' : 'e_lfanew'},
                        'headers/file_header/machine' : {'feature_name' : 'machine'},
                        'headers/file_header/number_of_sections' : {'feature_name' : 'number_of_sections'},
                        'headers/file_header/time_date_stamp' : {'feature_name' : 'time_date_stamp'},
                        'headers/file_header/pointer_to_symbol_table' : {'feature_name' : 'pointer_to_symbol_table'},
                        'headers/file_header/number_of_symbols' : {'feature_name' : 'number_of_symbols'},
                        'headers/file_header/size_of_optional_header' : {'feature_name' : 'size_of_optional_header'},
                        'headers/optional_header/major_linker_version' : {'feature_name' : 'major_linker_version'},
                        'headers/optional_header/minor_linker_version' : {'feature_name' : 'minor_linker_version'},
                        'headers/optional_header/size_of_code' : {'feature_name' : 'size_of_code'},
                        'headers/optional_header/size_of_initialized_data' : {'feature_name' : 'size_of_initialized_data'},
                        'headers/optional_header/address_of_entry_point' : {'feature_name' : 'address_of_entry_point'},
                        'headers/optional_header/base_of_code' : {'feature_name' : 'base_of_code'},
                        'headers/optional_header/base_of_data' : {'feature_name' : 'base_of_data'},
                        'headers/optional_header/image_base' : {'feature_name' : 'image_base'},
                        'headers/optional_header/section_alignment' : {'feature_name' : 'section_alignment'},
                        'headers/optional_header/file_alignment' : {'feature_name' : 'file_alignment'},
                        'headers/optional_header/major_os_version' : {'feature_name' : 'major_os_version'},
                        'headers/optional_header/minor_os_version' : {'feature_name' : 'minor_os_version'},
                        'headers/optional_header/major_image_version' : {'feature_name' : 'major_image_version'},
                        'headers/optional_header/minor_image_version' : {'feature_name' : 'minor_image_version'},
                        'headers/optional_header/major_subsystem_version' : {'feature_name' : 'major_subsystem_version'},
                        'headers/optional_header/minor_subsystem_version' : {'feature_name' : 'minor_subsystem_version'},
                        'headers/optional_header/win32_version_value' : {'feature_name' : 'win32_version_value'},
                        'headers/optional_header/size_of_image' : {'feature_name' : 'size_of_image'},
                        'headers/optional_header/size_of_headers' : {'feature_name' : 'size_of_headers'},
                        'headers/optional_header/checksum' : {'feature_name' : 'checksum'},
                        'headers/optional_header/subsystem' : {'feature_name' : 'subsystem'},
                        'headers/optional_header/size_of_stack_reserve' : {'feature_name' : 'size_of_stack_reserve'},
                        'headers/optional_header/size_of_stack_commit' : {'feature_name' : 'size_of_stack_commit'},
                        'headers/optional_header/size_of_heap_reserve' : {'feature_name' : 'size_of_heap_reserve'},
                        'headers/optional_header/size_of_heap_commit' : {'feature_name' : 'size_of_heap_commit'},
                        'headers/optional_header/loader_flags' : {'feature_name' : 'loader_flags'},
                        'headers/optional_header/number_of_rva_and_sizes' : {'feature_name' : 'number_of_rva_and_sizes'},
                        'imports/file_name' : {'feature_name' : 'imported_files',
                                                      'options'  : ['allow_multiple']},
                        'imports/imported_functions/function_name' : {'feature_name' : 'imported_functions',
                                                                                               'options'  : ['allow_multiple']},
                        'resources/type' : {'feature_name' : 'resource_types',
                                                     'options'  : ['allow_multiple']},
                        'resources/name' : {'feature_name' : 'resource_names',
                                                     'options'  : ['allow_multiple']},
                        'resources/size' : {'feature_name' : 'resource_sizes',
                                                     'options'  : ['allow_multiple']},
                        'resources/language' : {'feature_name' : 'resource_languages',
                                                         'options'  : ['allow_multiple']},
                        'sections/section_header/name' : {'feature_name' : 'section_names',
                                                                  'options'  : ['allow_multiple']},
                        'sections/section_header/virtual_size' : {'feature_name' : 'section_virtual_sizes',
                                                                          'options'  : ['allow_multiple']},
                        'sections/section_header/virtual_address' : {'feature_name' : 'section_virtual_addresses',
                                                                             'options'  : ['allow_multiple']},
                        'sections/entropy/value' : {'feature_name' : 'section_entropies',
                                                            'options'  : ['allow_multiple']}}